﻿using C1.Xaml;
using System;
using System.Collections.Generic;
using Windows.UI.Xaml.Controls;

// The Blank Page item template is documented at https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace FlexGridFreeze
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            flexGrid.ItemsSource = new List<User>()
            {
                new User(){ Id = 1, Name = "Dan" },
                new User(){ Id = 2, Name = "Joe" },
                new User(){ Id = 3, Name = "Fred" }
            };

            
        }

        private void _btnAsc_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            var collectionView = flexGrid.CollectionView as C1CollectionView;
            collectionView.CustomSort = new CustomSort() { SortDirection = ListSortDirection.Ascending };
        }

        private void _btnDesc_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            var collectionView = flexGrid.CollectionView as C1CollectionView;
            collectionView.CustomSort = new CustomSort() { SortDirection = ListSortDirection.Descending };
        }
    }

    public class CustomSort : IComparer<object>
    {
        public ListSortDirection SortDirection { get; set; } = ListSortDirection.Ascending;

        public int Compare(object x, object y)
        {
            var user1 = x as User;
            var user2 = y as User;

            // If id is 1 then row will remain on its position.
            if (user1.Id == 1 || user2.Id == 1)
                return 0;

            switch(SortDirection)
            {
                case ListSortDirection.Ascending:
                    return SortAscending(user1, user2);
                default:
                    return SortDescending(user1, user2);
            }
        }

        private int SortDescending(User user1, User user2)
        {
            if (user1.Id > user2.Id)
                return 1;
            else return -1;
        }

        private int SortAscending(User user1, User user2)
        {
            if (user1.Id > user2.Id)
                return -1;
            else return 1;
        }
    }

    public class User
    {
        public int Id { get; set; }
        public string Name { get; set; }
    }
}
